import { Course } from "src/schemas/course.schema";
import { CourseService } from "src/services/course.service";
export declare class CourseController {
    private courseService;
    constructor(courseService: CourseService);
    getAllCourses(): Promise<Course[]>;
    findByOrganizationId(organizationId?: string): Promise<Course[]>;
    getCourseById(courseId?: string, studentId?: string | null): Promise<Course>;
    findByStatus(status?: string, courseType?: string): Promise<Course[]>;
    findByInstructorId(instructorId?: string): Promise<Course[]>;
    findByCourseByType(courseType?: string): Promise<Course[]>;
    createCourse(thumbnail: Express.Multer.File, course: Course): Promise<Course>;
    editCourse(courseId: string, thumbnail: Express.Multer.File, updatedCourse: Course): Promise<Course>;
    deleteCourse(courseId: string): Promise<void>;
}
