"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseRoutineController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const courseRoutine_schema_1 = require("../schemas/courseRoutine.schema");
const courseRoutine_service_1 = require("../services/courseRoutine.service");
let CourseRoutineController = class CourseRoutineController {
    constructor(courseRoutineService) {
        this.courseRoutineService = courseRoutineService;
    }
    async create(courseRoutine) {
        try {
            return await this.courseRoutineService.create(courseRoutine);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(courseRoutineId, updatedCourseRoutine) {
        try {
            return await this.courseRoutineService.edit(courseRoutineId, updatedCourseRoutine);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getAll() {
        try {
            return await this.courseRoutineService.findAll();
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getById(courseRoutineId) {
        try {
            return await this.courseRoutineService.findById(courseRoutineId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByCourseId(courseId) {
        try {
            return await this.courseRoutineService.getByCourseId(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async delete(courseRoutineId) {
        try {
            await this.courseRoutineService.delete(courseRoutineId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Post)('create'),
    openapi.ApiResponse({ status: 201, type: require("../schemas/courseRoutine.schema").CourseRoutine }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [courseRoutine_schema_1.CourseRoutine]),
    __metadata("design:returntype", Promise)
], CourseRoutineController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('edit/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/courseRoutine.schema").CourseRoutine }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, courseRoutine_schema_1.CourseRoutine]),
    __metadata("design:returntype", Promise)
], CourseRoutineController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)('get-all'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/courseRoutine.schema").CourseRoutine] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], CourseRoutineController.prototype, "getAll", null);
__decorate([
    (0, common_1.Get)('get-by-id/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/courseRoutine.schema").CourseRoutine }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseRoutineController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)('get-by-courseId/:courseId'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/courseRoutine.schema").CourseRoutine }),
    __param(0, (0, common_1.Param)('courseId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseRoutineController.prototype, "getByCourseId", null);
__decorate([
    (0, common_1.Delete)('delete/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], CourseRoutineController.prototype, "delete", null);
CourseRoutineController = __decorate([
    (0, swagger_1.ApiTags)('CourseRoutines'),
    (0, common_1.Controller)('course-routines'),
    __metadata("design:paramtypes", [courseRoutine_service_1.CourseRoutineService])
], CourseRoutineController);
exports.CourseRoutineController = CourseRoutineController;
//# sourceMappingURL=courseRoutine.controller.js.map