import { QuestionMarks } from 'src/schemas/questionMarks.schema';
import { QuestionMarksService } from 'src/services/questionMarks.service';
export declare class QuestionMarksController {
    private readonly questionMarksService;
    constructor(questionMarksService: QuestionMarksService);
    create(assignmentFile: Express.Multer.File, questionMarks: QuestionMarks): Promise<QuestionMarks>;
    edit(questionMarksId: string, updatedQuestionMarks: QuestionMarks): Promise<QuestionMarks>;
    getById(questionMarksId: string): Promise<QuestionMarks>;
    getByStudentId(studentId: string): Promise<QuestionMarks[]>;
    getByStudentAndCourseId(courseId: string, studentId: string): Promise<QuestionMarks[]>;
    getByTo10Students(courseId: string): Promise<QuestionMarks[]>;
    getByStudentAndLessonId(lessonId: string, studentId: string): Promise<QuestionMarks[]>;
    getDetailsQuestionMarksByStudentId(studentId: string): Promise<QuestionMarks[]>;
    delete(questionMarksId: string): Promise<void>;
}
